/*
 * Gate Disk Controller
 * developed by: Santostefano Giovanni
 * contact: idmgiovanni@libero.it
 *
 * This program is a controller that verify if the GateDisk is inserted
 * If the correct gate disk is in the drive the program close itself,
 * otherwise the program invoke the poweroff command ad shutdown the computer
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <unistd.h>

int main()
{
	printf("GateDisk Controller\nby Santostefano Giovanni\n\n");
	//the file where the check result is stored
	FILE* stream;
	
	//the disk where the key is stored
	FILE* disk;
	
	//the key array
	int key[10000];
	
	//the result of the key elaboration
	double result=0.00;
	double result2=0.00;
	memset(&result,0,sizeof(double));
	memset(&result2,0,sizeof(double));
	
	int i=0;

	//Loading datas
	if((disk=fopen("/dev/fd0","rb"))==NULL)
	{
		printf("DISK NOT FOUND!\n");
		execl("/sbin/poweroff","");
	}
	
	if((stream=fopen("/root/key.mo","rb"))==NULL)
	{
		printf("RESULT FILE NOT FOUND!\n");
		execl("/sbin/poweroff","");
	}
	
	fread(key,sizeof(int),10000,disk);
	fread(&result2,sizeof(double),1,stream);
	
	fclose(disk);
	fclose(stream);

	
	//result composing
	for(i=0; i<1000; i+=10)
	{
		result+=key[i];
		result*=key[i+1];
		result/=key[i+2];
		result/=key[i+3];
		result+=sin(key[i+4]);
		result-=5*cos(key[i+5]);
		result-=key[i+6];
		result/=key[i+7];
		result*=key[i+8];
		result/=key[i+9];
	}
	
	
	if(result!=result2)
	{
		printf("AUTHENTICATION ERROR!\n");
		execl("/sbin/poweroff","");
	}
	
	
	printf("Access verified! Have a nice day!\n");
	return 0;
	
} 
