/*
 * Gate Disk Generator
 * developed by: Santostefano Giovanni
 * contact: idmgiovanni@libero.it
 *
 * This program is a GateDisk generator.
 * It creates a floppy disk with the key and a file with the result of an elaboration of the key
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int main()
{
	printf("GateDisk Generator\nby Santostefano Giovanni\n\n");
	//the file where the check result is stored
	FILE* stream;
	
	//the disk where the key is stored
	FILE* disk;
	
	//the key array
	int key[10000];
	
	//the result of the key elaboration
	double result=0.00;
	memset(&result,0,sizeof(double));
	
	
	int i=0;
		
	unsigned int c; //this int not initialized is usefull to make the random seed
	srand(time(0));
	
	//key generation
	printf("Generating random key\n");
	for(i=0; i<10000; i++)
	{
		key[i]=(int)((rand()%1000)+1);
	}
	
	//result composing
	printf("Computing the result\n");
	for(i=0; i<1000; i+=10)
	{
		result+=key[i];
		result*=key[i+1];
		result/=key[i+2];
		result/=key[i+3];
		result+=sin(key[i+4]);
		result-=5*cos(key[i+5]);
		result-=key[i+6];
		result/=key[i+7];
		result*=key[i+8];
		result/=key[i+9];
	}
	
	//Storing datas
	printf("Saving result and key\n");
	disk=fopen("/dev/fd0","wb");
	stream=fopen("key.mo","wb");
	
	fwrite(key,sizeof(int),10000,disk);
	fwrite(&result,sizeof(double),1,stream);
	
	fclose(disk);
	fclose(stream);
	
	return 0;
	
} 
